import std.stdio;
import std.string;

version(ENBMSGTRACE){
static string[int] msgdb ;
static bool        init_msgdb ;


int init_MsgTranslator()
{
  msgdb[32768]="WM_APP";
  msgdb[6]="WM_ACTIVATE";
  msgdb[28]="WM_ACTIVATEAPP";
  msgdb[864]="WM_AFXFIRST";
  msgdb[895]="WM_AFXLAST";
  msgdb[780]="WM_ASKCBFORMATNAME";
  msgdb[75]="WM_CANCELJOURNAL";
  msgdb[31]="WM_CANCELMODE";
  msgdb[533]="WM_CAPTURECHANGED";
  msgdb[781]="WM_CHANGECBCHAIN";
  msgdb[258]="WM_CHAR";
  msgdb[47]="WM_CHARTOITEM";
  msgdb[34]="WM_CHILDACTIVATE";
  msgdb[771]="WM_CLEAR";
  msgdb[16]="WM_CLOSE";
  msgdb[273]="WM_COMMAND";
  msgdb[68]="WM_COMMNOTIFY";
  msgdb[65]="WM_COMPACTING";
  msgdb[57]="WM_COMPAREITEM";
  msgdb[123]="WM_CONTEXTMENU";
  msgdb[769]="WM_COPY";
  msgdb[74]="WM_COPYDATA";
  msgdb[1]="WM_CREATE";
  msgdb[309]="WM_CTLCOLORBTN";
  msgdb[310]="WM_CTLCOLORDLG";
  msgdb[307]="WM_CTLCOLOREDIT";
  msgdb[308]="WM_CTLCOLORLISTBOX";
  msgdb[306]="WM_CTLCOLORMSGBOX";
  msgdb[311]="WM_CTLCOLORSCROLLBAR";
  msgdb[312]="WM_CTLCOLORSTATIC";
  msgdb[768]="WM_CUT";
  msgdb[259]="WM_DEADCHAR";
  msgdb[45]="WM_DELETEITEM";
  msgdb[2]="WM_DESTROY";
  msgdb[775]="WM_DESTROYCLIPBOARD";
  msgdb[537]="WM_DEVICECHANGE";
  msgdb[27]="WM_DEVMODECHANGE";
  msgdb[126]="WM_DISPLAYCHANGE";
  msgdb[776]="WM_DRAWCLIPBOARD";
  msgdb[43]="WM_DRAWITEM";
  msgdb[563]="WM_DROPFILES";
  msgdb[10]="WM_ENABLE";
  msgdb[22]="WM_ENDSESSION";
  msgdb[289]="WM_ENTERIDLE";
  msgdb[529]="WM_ENTERMENULOOP";
  msgdb[561]="WM_ENTERSIZEMOVE";
  msgdb[20]="WM_ERASEBKGND";
  msgdb[530]="WM_EXITMENULOOP";
  msgdb[562]="WM_EXITSIZEMOVE";
  msgdb[29]="WM_FONTCHANGE";
  msgdb[135]="WM_GETDLGCODE";
  msgdb[49]="WM_GETFONT";
  msgdb[51]="WM_GETHOTKEY";
  msgdb[127]="WM_GETICON";
  msgdb[36]="WM_GETMINMAXINFO";
  msgdb[13]="WM_GETTEXT";
  msgdb[14]="WM_GETTEXTLENGTH";
  msgdb[856]="WM_HANDHELDFIRST";
  msgdb[863]="WM_HANDHELDLAST";
  msgdb[83]="WM_HELP";
  msgdb[786]="WM_HOTKEY";
  msgdb[276]="WM_HSCROLL";
  msgdb[782]="WM_HSCROLLCLIPBOARD";
  msgdb[39]="WM_ICONERASEBKGND";
  msgdb[272]="WM_INITDIALOG";
  msgdb[278]="WM_INITMENU";
  msgdb[279]="WM_INITMENUPOPUP";
  msgdb[81]="WM_INPUTLANGCHANGE";
  msgdb[80]="WM_INPUTLANGCHANGEREQUEST";
  msgdb[256]="WM_KEYDOWN";
  msgdb[257]="WM_KEYUP";
  msgdb[8]="WM_KILLFOCUS";
  msgdb[546]="WM_MDIACTIVATE";
  msgdb[551]="WM_MDICASCADE";
  msgdb[544]="WM_MDICREATE";
  msgdb[545]="WM_MDIDESTROY";
  msgdb[553]="WM_MDIGETACTIVE";
  msgdb[552]="WM_MDIICONARRANGE";
  msgdb[549]="WM_MDIMAXIMIZE";
  msgdb[548]="WM_MDINEXT";
  msgdb[564]="WM_MDIREFRESHMENU";
  msgdb[547]="WM_MDIRESTORE";
  msgdb[560]="WM_MDISETMENU";
  msgdb[550]="WM_MDITILE";
  msgdb[44]="WM_MEASUREITEM";
  msgdb[0x0125]="WM_UNINITMENUPOPUP";
  msgdb[290]="WM_MENURBUTTONUP";
  msgdb[0x0126]="WM_MENUCOMMAND";
  msgdb[0x0124]="WM_MENUGETOBJECT";
  msgdb[0x0123]="WM_MENUDRAG";
  msgdb[0x0127]="WM_CHANGEUISTATE";
  msgdb[0x0128]="WM_UPDATEUISTATE";
  msgdb[0x0129]="WM_QUERYUISTATE";
  msgdb[288]="WM_MENUCHAR";
  msgdb[287]="WM_MENUSELECT";
  msgdb[3]="WM_MOVE";
  msgdb[534]="WM_MOVING";
  msgdb[134]="WM_NCACTIVATE";
  msgdb[131]="WM_NCCALCSIZE";
  msgdb[129]="WM_NCCREATE";
  msgdb[130]="WM_NCDESTROY";
  msgdb[132]="WM_NCHITTEST";
  msgdb[163]="WM_NCLBUTTONDBLCLK";
  msgdb[161]="WM_NCLBUTTONDOWN";
  msgdb[162]="WM_NCLBUTTONUP";
  msgdb[169]="WM_NCMBUTTONDBLCLK";
  msgdb[167]="WM_NCMBUTTONDOWN";
  msgdb[168]="WM_NCMBUTTONUP";
  msgdb[171]="WM_NCXBUTTONDOWN";
  msgdb[172]="WM_NCXBUTTONUP";
  msgdb[173]="WM_NCXBUTTONDBLCLK";
  msgdb[0x02A0]="WM_NCMOUSEHOVER";
  msgdb[0x02A2]="WM_NCMOUSELEAVE";
  msgdb[160]="WM_NCMOUSEMOVE";
  msgdb[133]="WM_NCPAINT";
  msgdb[166]="WM_NCRBUTTONDBLCLK";
  msgdb[164]="WM_NCRBUTTONDOWN";
  msgdb[165]="WM_NCRBUTTONUP";
  msgdb[40]="WM_NEXTDLGCTL";
  msgdb[531]="WM_NEXTMENU";
  msgdb[78]="WM_NOTIFY";
  msgdb[85]="WM_NOTIFYFORMAT";
  msgdb[0]="WM_NULL";
  msgdb[15]="WM_PAINT";
  msgdb[777]="WM_PAINTCLIPBOARD";
  msgdb[38]="WM_PAINTICON";
  msgdb[785]="WM_PALETTECHANGED";
  msgdb[784]="WM_PALETTEISCHANGING";
  msgdb[528]="WM_PARENTNOTIFY";
  msgdb[770]="WM_PASTE";
  msgdb[896]="WM_PENWINFIRST";
  msgdb[911]="WM_PENWINLAST";
  msgdb[72]="WM_POWER";
  msgdb[536]="WM_POWERBROADCAST";
  msgdb[791]="WM_PRINT";
  msgdb[792]="WM_PRINTCLIENT";
  msgdb[ 0x0319]="WM_APPCOMMAND ";
  msgdb[55]="WM_QUERYDRAGICON";
  msgdb[17]="WM_QUERYENDSESSION";
  msgdb[783]="WM_QUERYNEWPALETTE";
  msgdb[19]="WM_QUERYOPEN";
  msgdb[35]="WM_QUEUESYNC";
  msgdb[18]="WM_QUIT";
  msgdb[774]="WM_RENDERALLFORMATS";
  msgdb[773]="WM_RENDERFORMAT";
  msgdb[32]="WM_SETCURSOR";
  msgdb[7]="WM_SETFOCUS";
  msgdb[48]="WM_SETFONT";
  msgdb[50]="WM_SETHOTKEY";
  msgdb[128]="WM_SETICON";
  msgdb[11]="WM_SETREDRAW";
  msgdb[12]="WM_SETTEXT";
  msgdb[26]="WM_SETTINGCHANGE";
  msgdb[24]="WM_SHOWWINDOW";
  msgdb[5]="WM_SIZE";
  msgdb[779]="WM_SIZECLIPBOARD";
  msgdb[532]="WM_SIZING";
  msgdb[42]="WM_SPOOLERSTATUS";
  msgdb[125]="WM_STYLECHANGED";
  msgdb[124]="WM_STYLECHANGING";
  msgdb[262]="WM_SYSCHAR";
  msgdb[21]="WM_SYSCOLORCHANGE";
  msgdb[274]="WM_SYSCOMMAND";
  msgdb[263]="WM_SYSDEADCHAR";
  msgdb[260]="WM_SYSKEYDOWN";
  msgdb[261]="WM_SYSKEYUP";
  msgdb[82]="WM_TCARD";
  msgdb[794]="WM_THEMECHANGED";
  msgdb[30]="WM_TIMECHANGE";
  msgdb[275]="WM_TIMER";
  msgdb[772]="WM_UNDO";
  msgdb[1024]="WM_USER";
  msgdb[84]="WM_USERCHANGED";
  msgdb[46]="WM_VKEYTOITEM";
  msgdb[277]="WM_VSCROLL";
  msgdb[778]="WM_VSCROLLCLIPBOARD";
  msgdb[71]="WM_WINDOWPOSCHANGED";
  msgdb[70]="WM_WINDOWPOSCHANGING";
  msgdb[26]="WM_WININICHANGE";
  msgdb[255]="WM_INPUT";
  msgdb[256]="WM_KEYFIRST";
  msgdb[264]="WM_KEYLAST";
  msgdb[136]="WM_SYNCPAINT";
  msgdb[33]="WM_MOUSEACTIVATE";
  msgdb[512]="WM_MOUSEMOVE";
  msgdb[513]="WM_LBUTTONDOWN";
  msgdb[514]="WM_LBUTTONUP";
  msgdb[515]="WM_LBUTTONDBLCLK";
  msgdb[516]="WM_RBUTTONDOWN";
  msgdb[517]="WM_RBUTTONUP";
  msgdb[518]="WM_RBUTTONDBLCLK";
  msgdb[519]="WM_MBUTTONDOWN";
  msgdb[520]="WM_MBUTTONUP";
  msgdb[521]="WM_MBUTTONDBLCLK";
  msgdb[522]="WM_MOUSEWHEEL";
  msgdb[512]="WM_MOUSEFIRST";
  msgdb[523]="WM_XBUTTONDOWN";
  msgdb[524]="WM_XBUTTONUP";
  msgdb[525]="WM_XBUTTONDBLCLK";
  msgdb[525]="WM_MOUSELAST";
  msgdb[522]="WM_MOUSELAST";
  msgdb[0x2A1]="WM_MOUSEHOVER";
  msgdb[0x2A3]="WM_MOUSELEAVE";

  return(0) ;
}


string MsgTranslate(int msg){

  if( init_msgdb==false ){
    init_MsgTranslator() ;
    init_msgdb=true ;
  }
  if( (msg in msgdb)!=null ){
    return( msgdb[msg] ) ;
  }
  return( format("Unknown %08x",msg) ) ;
}
}